<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="所属公司" prop="companyId">
        <el-select
          v-model="queryParams.companyId"
          filterable
          remote
          reserve-keyword
          placeholder="请输入公司名称搜索"
          :remote-method="searchCompanies"
          :loading="companySearchLoading"
          style="width: 220px"
          clearable
          size="small"
        >
          <el-option
            v-for="item in companyOptions"
            :key="item.dictValue"
            :label="item.dictLabel"
            :value="item.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="appid" prop="appid">
        <el-input
          v-model="queryParams.appid"
          placeholder="请输入appid"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['course:playSourceConfig:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['course:playSourceConfig:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['course:playSourceConfig:remove']"
        >删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 开关配置对话框 -->
    <el-dialog title="开关配置" :visible.sync="switchDialogVisible" width="500px" class="switch-dialog">
      <el-form :model="switchForm" label-width="100px">
        <el-form-item label="AppId">
          <el-input v-model="switchForm.appId" :disabled="true"></el-input>
        </el-form-item>
        <el-form-item label="开关状态">
          <el-switch
            v-model="switchForm.switchStatus"
            active-text="开启"
            inactive-text="关闭"
            active-value="001"
            inactive-value="002">
          </el-switch>
        </el-form-item>
        <el-form-item label="配置信息" v-if="switchForm.configInfo">
          <el-input
            type="textarea"
            :rows="4"
            v-model="switchForm.configInfo"
            :disabled="true">
          </el-input>
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
                <el-button @click="switchDialogVisible = false">取 消</el-button>
                <el-button type="primary" @click="submitSwitchConfig">确 定</el-button>
            </span>
    </el-dialog>

    <el-table v-loading="loading" :data="list" @selection-change="handleSelectionChange" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="id" />
      <el-table-column label="名称" align="center" prop="name" />
      <el-table-column label="所属公司" align="center" prop="companyId" :formatter="companyNameFormatter"/>
      <el-table-column label="图标" align="center" prop="img">
        <template slot-scope="scope">
          <el-image
            style="width: 80px; height: 80px"
            :src="scope.row.img"
            :preview-src-list="[scope.row.img]">
          </el-image>
        </template>
      </el-table-column>
      <el-table-column label="原始ID" align="center" prop="originalId" />
      <el-table-column label="appId" align="center" prop="appid" />
      <el-table-column label="secret" align="center" prop="secret" />
      <el-table-column label="token" align="center" prop="token" />
      <el-table-column label="aesKey" align="center" prop="aesKey" />
      <el-table-column label="msgDataFormat" align="center" prop="msgDataFormat" />
      <el-table-column label="类型" align="center" prop="type">
        <template slot-scope="scope">
          <dict-tag  :options="typesOptions" :value="scope.row.type"/>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <el-table-column label="修改时间" align="center" prop="updateTime" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['course:playSourceConfig:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['course:playSourceConfig:remove']"
          >删除</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-setting"
            @click="handleSwitchConfig(scope.row)"
          >是否展示销售</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改点播配置对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body :before-close="resetOption">
      <el-form ref="form" :model="form" :rules="rules" label-width="130px">
        <el-form-item label="名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="所属公司" prop="companyId">
          <el-select
            v-model="form.companyId"
            filterable
            remote
            reserve-keyword
            placeholder="请输入公司名称搜索"
            :remote-method="searchCompanies"
            :loading="companySearchLoading"
            style="width: 220px"
            clearable
            size="small"
          >
            <el-option
              v-for="item in companyOptions"
              :key="item.dictValue"
              :label="item.dictLabel"
              :value="item.dictValue"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="图标" prop="img">
          <image-upload v-model="form.img" :file-type='["png", "jpg", "jpeg"]' :limit="1"/>
        </el-form-item>
        <el-form-item label="类型" prop="type">
          <el-select
            v-model="form.type"
            placeholder="请选择类型">
            <el-option
              v-for="item in typesOptions"
              :key="item.dictValue"
              :label="item.dictLabel"
              :value="item.dictValue"/>
          </el-select>
        </el-form-item>
        <el-form-item label="原始id" prop="originalId">
          <el-input v-model="form.originalId" placeholder="请输入原始id" />
        </el-form-item>
        <el-form-item label="appid" prop="appid">
          <el-input v-model="form.appid" placeholder="请输入appid" />
        </el-form-item>
        <el-form-item label="secret" prop="secret">
          <el-input v-model="form.secret" placeholder="请输入secret" />
        </el-form-item>
        <el-form-item label="token" prop="token">
          <el-input v-model="form.token" placeholder="请输入token" />
        </el-form-item>
        <el-form-item label="aesKey" prop="aesKey">
          <el-input v-model="form.aesKey" placeholder="请输入aesKey" />
        </el-form-item>
        <el-form-item label="msgDataFormat" prop="msgDataFormat">
          <el-input v-model="form.msgDataFormat" placeholder="请输入msgDataFormat" />
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import {list, get, update, add, del} from '@/api/course/coursePlaySourceConfig'
import {updateIsTownOn} from "@/api/system/config";
import { allList } from '@/api/company/company'
import { resetForm } from '@/utils/common'

export default {
  name: 'CoursePlaySourceConfig',
  data() {
    return {
      switchDialogVisible: false,
      // 公司搜索相关
      companySearchLoading: false,
      companyOptions: [],
      formatterCompanyOptions: [],
      switchForm: {
        appId: '',
        switchStatus: '001',
      },
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: null,
        appid: null
      },
      showSearch: true,
      single: true,
      multiple: true,
      ids: [],
      loading: false,
      list: [],
      total: 0,
      typesOptions: [],
      title: null,
      open: false,
      form: {},
      rules: {
        name: [
          { required: true, message: "名称不能为空", trigger: "blur" }
        ],
        // companyId: [
        //   { required: true, message: "所属公司不能为空", trigger: "blur" }
        // ],
        appid: [
          { required: true, message: "appid不能为空", trigger: "blur" }
        ],
        img: [
          { required: true, message: "图标不能为空", trigger: "blur" }
        ],
        type: [
          { required: true, message: "类型不能为空", trigger: "blur" }
        ],
        originalId: [
          { required: true, message: "原始id不能为空", trigger: "blur" }
        ],
        secret: [
          { required: true, message: "secret不能为空", trigger: "blur" }
        ],
        token: [
          { required: true, message: "token不能为空", trigger: "blur" }
        ],
        aesKey: [
          { required: true, message: "aesKey不能为空", trigger: "blur" }
        ],
        msgDataFormat: [
          { required: true, message: "msgDataFormat不能为空", trigger: "blur" }
        ]
      }
    }
  },
  created() {
    this.getDicts("play_source_type").then(response => {
      this.typesOptions = response.data.map(item =>  {
        return {
        ...item,
        listClass: 'primary'}
      })
    });
    //初始化formatterCompanyOptions
    allList().then(e => {
      this.formatterCompanyOptions = e.rows;
    });
    this.getList();
  },
  methods: {
    resetForm,
    resetOption(){
      console.log(1)
      this.companyOptions = [];
      this.open = false;
    },


    // 处理开关配置
    handleSwitchConfig(row) {
      this.switchForm.appId = row.appid;
      this.switchForm.switchStatus = "001"; // 默认关闭状态

      // 调用接口获取开关状态
      this.getSwitchConfig(row.appid);
      this.switchDialogVisible = true;
    },
    /** 搜索公司 */
    searchCompanies(query) {
      this.companySearchLoading = true;
      allList().then(response => {
        this.companyOptions = response.rows;
        if (query) {
          this.companyOptions = this.companyOptions.filter(item =>
            item.dictLabel.includes(query)
          );
        }
        this.companySearchLoading = false;
      }).catch(()=>{
        this.companySearchLoading = false;
      });
    },
    companyNameFormatter(row){
      let company = this.formatterCompanyOptions.filter(item => item.dictValue === row.companyId)[0];
      return company ? company.dictLabel : '';
    },

    // 获取开关配置
    getSwitchConfig(appId) {
      const params = {
        appId: this.switchForm.appId
      };
      updateIsTownOn(params).then(response=>{
        if (response.code === 200) {
          if ( response.date){
            this.switchForm.switchStatus = response.date;
          }
        } else {
          this.$message.error('获取配置失败: ' + response.msg);
        }
      }).catch(error => {
        this.$message.error('请求失败: ' + error.message);
      });
    },

    // 提交开关配置
    submitSwitchConfig() {
      const params = {
        appId: this.switchForm.appId,
        bock: this.switchForm.switchStatus
      };
      updateIsTownOn(params).then(response=>{
        if (response.code === 200) {
          this.$message.success('配置更新成功');
          this.switchDialogVisible = false;
        } else {
          this.$message.error('更新失败: ' + response.msg);
        }
      })
    },


    getList() {
      this.loading = true;
      list(this.queryParams).then(response => {
        this.list = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    resetQuery() {
      this.resetForm("queryForm");
      this.getList();
    },
    handleAdd() {
      this.reset()
      this.open = true
      this.title = "添加小程序配置"
    },
    handleUpdate(row) {
      this.reset()
      const id = row.id || this.ids
      get(id).then(response => {
        this.form = {
          ...response.data,
          type: response.data.type.toString()
        }
        this.open = true
        this.title = "修改小程序配置"
      })
    },
    handleDelete(row) {
      const id = row.id || this.ids
      this.$confirm('是否确认删除小程序配置编号为"' + id + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function() {
        return del(id);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      }).catch(() => {});
    },
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            update(this.form).then(response => {
              const {code, msg} = response
              if (code !== 200) {
                this.msgError(msg)
                return
              }
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            add(this.form).then(response => {
              const {code, msg} = response
              if (code !== 200) {
                this.msgError(msg)
                return
              }
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    cancel() {
      this.open = false;
      this.reset();
    },
    reset() {
      this.form = {
        id: null,
        name: null,
        appid: null,
        secret: null,
        img: null,
        originalId: null,
        token: 'cbnd7lJvkripVOpyTFAna6NAWCxCrvC',
        aesKey: 'HlEiBB55eaWUaeBVAQO3cWKWPYv1vOVQSq7nFNICw4E',
        msgDataFormat: 'JSON',
        type: '1'
      }
      this.resetForm("form");
    }
  },
}
</script>

<style scoped>

</style>
